<?php
/*
 This program is free software. You can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License.
*/

if (eregi("class-ctree.php",$_SERVER['PHP_SELF'])) {
    Header("Location: /");
    die();
}

function expand_tree_node($name)
{
	print "<script language=\"JavaScript\">switchview($name)</script>";
}

class CTree
{
	var $cssnode = "cssnormal";
	var $linktarget = "";
	var $defaulticon = "images/folder.gif";

	var $node;
	var $INITED;
	var $TOPLEVEL;

	var $styles = array();

function CTree()	{
	$this->INITED = FALSE;
}

function addnode($level, $label, $url = "", $icon = "", $name = "", $expanted = false) 	{
		if ($icon == "") $icon = $this->defaulticon;
		if ($this->INITED == FALSE)	{
			$this->INITED = TRUE;
			$this->TOPLEVEL = $level;

			$this->node[0]["level"] = $level;
			$this->node[0]["label"] = $label;
			$this->node[0]["url"] = $url;
			$this->node[0]["icon"] = $icon;
			$this->node[0]["expanted"] = $expanted;
			$this->node[0]["name"] = $name;
		}	else	{
			$nodenum = count($this->node);

			if ($level < $this->TOPLEVEL) $level = $this->TOPLEVEL;

			$this->node[$nodenum]["level"] = $level;
			$this->node[$nodenum]["label"] = $label;
			$this->node[$nodenum]["url"] = $url;
			$this->node[$nodenum]["icon"] = $icon;
			$this->node[$nodenum]["expanted"] = $expanted;
			$this->node[$nodenum]["name"] = $name;

		}

		if ($expanted && $level > 0)
		{
        	$this->expanduptree($level);
		}
	}

	function showtree()
	{
		if ($this->INITED) {
			$this->prewrite();
			$this->showsubtree(0);
		}
	}

//show the current sub tree with root $currentnode, and return the
//node index of next node that is in the same level of $currentnode (the root of next sub tree)
//if a node with SAME level found, return the node id of next nod
//otherwise return FALSE;

function expanduptree($ALevel)
{
	for ($i=count($this->node)-1;$i>0;$i--)
	{
//		print "!!" . $this->node[$i]['level'];
		if ($this->node[$i]['level'] < $ALevel)
		{
			$this->node[$i]['expanted'] = true;
			if ($this->node[$i]['level'] > 0)
			{
				$this->expanduptree($this->node[$i]['level']);
			}
			break;
		}
	}
}

function showsubtree($rootnode)	{

		$mylevel = isset($this->node[$rootnode]["level"]) ?	$this->node[$rootnode]["level"] : $this->ROOTLEVEL;

		//auto generate the div leading and ending codes
		$myclass = $this->cssnode;
		$myname = (isset($this->node[$rootnode-1]["name"]) && $this->node[$rootnode-1]["name"] <> "") ? $this->node[$rootnode-1]["name"] : "node$rootnode";

		$divleadingcode = "\n<!-- start div --><div class=\"$myclass\" id=\"".$myname."\">\n";
		$divendingcode = "</div><!-- end div -->\n";

		echo("$divleadingcode");
		$this->shownode($rootnode);

		$nextnode = $rootnode + 1;
		$nextlevel = isset($this->node[$nextnode]["level"]) ?	$this->node[$nextnode]["level"] : -999;

		while($nextlevel >= $mylevel)	{
			if ($nextlevel == $mylevel)	{
				$this->shownode($nextnode);
				$nextnode++;
			} else	{
				$nextnode = $this->showsubtree($nextnode);
			}

			$nextlevel = isset($this->node[$nextnode]["level"]) ?	$this->node[$nextnode]["level"] : -999;
		}
		echo("$divendingcode");
		return $nextnode;
	}

function shownode($rootnode)	{
		$mylevel = isset($this->node[$rootnode]["level"]) ?	$this->node[$rootnode]["level"] : $this->ROOTLEVEL;
		$mylabel = isset($this->node[$rootnode]["label"]) ?	$this->node[$rootnode]["label"] : "ERR";
		$myurl = isset($this->node[$rootnode]["url"]) ?	$this->node[$rootnode]["url"] : "";
		$myicon = isset($this->node[$rootnode]["icon"]) ?	$this->node[$rootnode]["icon"] : $this->defaulticon;
		$myname = (isset($this->node[$rootnode]["name"]) && $this->node[$rootnode]["name"] <> "") ? $this->node[$rootnode]["name"] : "node".$rootnode+1;

		$nextlevel = isset($this->node[$rootnode+1]["level"]) ?	$this->node[$rootnode+1]["level"] : -999;

		//auto generate the initial gap of the icon
		$leadingcode = "";
		for ($i = 0; $i<$mylevel - $this->TOPLEVEL; $i++)	{
			$leadingcode .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
		}

		//auto generate the expand icon links
		$nextnode = $rootnode + 1;
		$expandleadingcode = "<a href=\"javascript:switchview(".$myname.");\">";
		$expandendingcode = "</a>";

		//auto generate the linking code
		if ($myurl != "")	{
			$mytarget = $this->linktarget;
			$linkleadingcode = "<a href=\"$myurl\" target=\"$mytarget\">";
			$linkendingcode = "</a>";
		} else	{
			$linkleadingcode = $linkendingcode = "";
		}

		//show current node
		echo("$leadingcode");
		if ($mylevel < $nextlevel)	{
			echo("&nbsp;$expandleadingcode<img name=\"imgnode".$nextnode."\" src=\"".$myicon."\" border=\"0\" alt=\"Развернуть меню '".$mylabel."'\">$expandendingcode");
		} else	{
			echo("&nbsp;<img src=\"".$myicon."\" border=\"0\">");
		}

		//show text label
		echo("&nbsp;&nbsp;$linkleadingcode$mylabel$linkendingcode<br>\n");
}


function prewrite() 	{
		echo("\n<style type=\"text/css\">\n");
		for ($i=1;$i<count($this->node);$i++)
		{
			$name = ($this->node[$i]['name'] <> "") ? $this->node[$i]['name'] : "node".$i;
			$style = $this->node[$i]['expanted'] ? "inline" : "none";
			echo ("#".$name." {display:".$style.";}\n");
		}
		echo("</style>\n");
	}	//end of function
}

?>