<?php
/*
 This program is free software. You can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License.
*/

class NetAms {

	var $processor = 0;
	var $fp = null;
	var $version = "";
	var $build = "";
	var $connected = false;
	var $configure = false;
	var $in_service = false;
	var $buffer = '';

	var $errorno = 0;
	var $errormessage = array();

	var $cfg = array();

	function NetAms($client = "", $ctimeout = 0, $cmdtimeout = 0)
	{
		$this->cfg['client'] = ($client <> "") ? $client : "telnet";
		$this->cfg['connecttimeout'] = ($ctimeout <> 0) ? intval($ctimeout) : 10;
		$this->cfg['cmdtimeout'] = ($cmdtimeout <> 0) ? intval($cmdtimeout) : 125000;
		$this->errormessage[0] = "connect ok.";
		$this->errormessage[1] = "can`not connect to host";
		$this->errormessage[2] = "can`not resolv host";
		$this->errormessage[3] = "can`not login to NetAms server";
		$this->errormessage[4] = "can`not make command exec --> check safe mode in php.ini";
	}

	function connect()
	{
		$server = $this->cfg['host'];
		$port   = $this->cfg['port'];
		$login  = $this->cfg['user'];
		$pwd    = $this->cfg['pass'];

		if ($this->cfg['client'] == 'ctl')
		{
			$buffer = "";
			$ret = 0;
			exec($this->cfg['ctl'] . " show version", $buffer, $ret);
			if ($ret == 127)
			{
				$this->errorno = 4;
				return;
			}
		}
		else  // telnet
		{

			if (preg_match('/[^0-9.]/',$server))
			{
				$ip = gethostbyname($server);
				if ($ip == $server)
				{
					$ip = "";
					$this->errorno = 2;
				}
			} else $ip = $server;

			if ($ip <> "")
			{
				if ($this->fp = @fsockopen($ip, $port, $error, $error_str, $this->cfg['connecttimeout']))
				{
					if (!$this->login($login, $pwd)){
						$this->errorno = 3;
						return "";
					}
				}
				else $this->errorno = 1;
			} else $this->errorno = 2;
		}

		$this->connected = true;
		$ver = $this->sendcommand("show version");
		$tmp2 = explode(" ",$ver[0]);
		if ($tmp2[1] == "version")
		{
			$this->version = $tmp2[2];
			$this->build = substr($tmp2[4],0,-1);
		}
		else
		{
			$this->version = $tmp2[1];
			$this->build = substr($tmp2[2],1,-1);
		}

	}

	function disconnect()
	{
		if ($this->fp)
		{
			if($this->in_service) $this->sendcommand("exit");
			if($this->configure) $this->sendcommand("exit");
			fclose($this->fp);
		}
	}

	function getinfo(){
		$result = $this->sendcommand("show version");
		$info['general'] = $result[0];
		$info['runtime'] = @$result[1];
		$info['systemtime'] = @$result[2];
		$info['cpu'] = @$result[3];
		$info['proc'] = @$result[4];
		$info['mem'] = @$result[5];
		return $info;
	}

	function getconfig(){
		$result = $this->sendcommand("show config");
		return $result;
	}

	function config_save()
	{
		$this->sendcommand("save");
	}

	#####################
    # Units wrok block #
    #####################

	function units($type = "")
	{
		$result = $this->sendcommand(trim("show units " . $type), false);
		$tmp = array_slice($result,1);
		$res = array();
		for($i=0;$i<count($tmp);$i++)
		{
			$tmp2 = explode("|",$tmp[$i]);
			for($n=0;$n<count($tmp2);$n++) $tmp2[$n] = trim($tmp2[$n]);
			$res[$i]['type'] = $tmp2[0];
			$res[$i]['oid'] = $tmp2[1];
			$res[$i]['db_oid'] = base_convert($res[$i]['oid'],16,10);
			$res[$i]['name'] = $tmp2[2];
			$res[$i]['nlp'] = $tmp2[3];
			$res[$i]['parent'] = ($tmp2[4] <> "<>") ? $tmp2[4] : "";
			if ($this->version == "3.4.0")
			{
				preg_match("([a-z0-9&\-_.]+?@[\w\-]+\.([\w\-\.]+\.)?[\w]+)", $tmp2[5], $mail);
				preg_match_all("/([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.)([0-9]{1,3}\/[0-9]{1,2}|[0-9]{1,3})/", $tmp2[5], $ip);
				$res[$i]['email'] = @$mail[0];
				$res[$i]['param'] = implode(" ", $ip[0]);
			}
			else
			{
				$res[$i]['email'] = $tmp2[5];
				$res[$i]['param'] = trim(str_replace("IP: ","",$tmp2[6]));
			}
		}
		return $res;
	}

	function unit_edit($type, $oid, $param)
	{
		$oid = ($oid <> "") ? "oid ".$oid." " : "";
		$command = trim("enable && configure terminal && service processor && unit ".$type." ".$oid.$param);
		$this->sendcommand($command);
	}

	function unit_delete($type, $oid)
	{
		$command = trim("enable && configure terminal && service processor && no unit ".$type." oid ".$oid);
		return $this->sendcommand($command);
	}

	function unit_policy($oid){
		$result = $this->sendcommand("show list oid ".trim($oid));
		$result = $this->kill2space(implode("\n",$result));

		$act_policy = array();
		$fw_policy  = array();
		$sys_policy = array();

		$tmp = explode("\n",$result);
		$tmp = array_slice($tmp,1);

		if (count($tmp) < 1) return array();

		if ($tmp[0] <> "SYST policy is not set")
		{

		}
		else
			$count = 2;

		$tmp = array_slice($tmp,$count);

		if ($tmp[0] <> "FW policy is not set")
		{
			$count = 0;
			for($i=0;$i<count($tmp);$i++)
			{
				$count ++;
				if (eregi("ACCT policy",$tmp[$i]))
					break;
				$tmp2 = explode(" ",trim($tmp[$i]));
				$fw_policy[$i]['name']   = $tmp2[1];
				$fw_policy[$i]['oid']    = $tmp2[0];
				$fw_policy[$i]['db_oid'] = base_convert($tmp2[0],16,10);
			}
		}
		else
			$count = 2;

		$tmp = array_slice($tmp,$count);

		if ($tmp[0] <> "ACCT policy is not set")
		{
			for($i=0;$i<count($tmp);$i++)
			{
				$tmp2 = explode(" ",trim($tmp[$i]));
				if (count($tmp2) == 4)
				{
					$act_policy[$i]['name']   = $tmp2[1];
					$act_policy[$i]['oid']    = $tmp2[0];
					$act_policy[$i]['db_oid'] = base_convert($tmp2[0],16,10);
					$act_policy[$i]['flag']   = "";
				}
				else
				{
					$act_policy[$i]['name']   = $tmp2[2];
					$act_policy[$i]['oid']    = $tmp2[1];
					$act_policy[$i]['db_oid'] = base_convert($tmp2[1],16,10);
					$act_policy[$i]['flag']   = $tmp2[0];
				}
			}
		}

		$res['sys']  = $sys_policy;
		$res['acct'] = $act_policy;
		$res['fw']   = $fw_policy;
		return $res;
	}

	#########################################################################

	#####################
    # Policy wrok block #
    #####################

	function policy()
	{
		$result = $this->sendcommand("show policy");
		$tmp = array_slice($result,1);
		$res = array();
		for($i=0;$i<count($tmp);$i++)
		{
			$tmp2 = explode("|",$tmp[$i]);
			if ($this->version == "3.4.0")
			{
				$tmp3 = explode(" ",trim($tmp2[1]));
				$res[$i]['oid'] = trim($tmp2[0]);
				$res[$i]['db_oid'] = base_convert($res[$i]['oid'],16,10);
				$res[$i]['name'] = trim($tmp3[0]);
				$res[$i]['param'] = trim(str_replace($tmp3[0]." ","",$tmp2[1]));
			}
			else
			{
				$res[$i]['oid'] = trim($tmp2[0]);
				$res[$i]['db_oid'] = base_convert($res[$i]['oid'],16,10);
				$res[$i]['name'] = trim($tmp2[1]);
				$res[$i]['param'] = trim($tmp2[2]);
			}
		}
		return $res;
	}

	function policy_edit($AParam, $AOid = "")
	{
    	$command = "enable && configure terminal && service processor && policy " . ( ($AOid <> "") ? "oid " . $AOid . " " : "" ) . $AParam ;
    	$this->sendcommand($command);
	}

	function policy_delete($AOid)
	{
    	$command = "enable && configure terminal && service processor && no policy oid " . $AOid;
    	$this->sendcommand($command);
	}

	function policy_get_default_acct()
	{
        $ret    = $this->sendcommand("show service processor");
        for($i=0;$i<count($ret);$i++)
        {
        	if (substr($ret[$i],0,19) == "default acct-policy")
        	{
        		return explode(" ",str_replace("default acct-policy ", "", $ret[$i]));
        	}
        }
        return array();
	}

	function policy_set_default_acct($APolicys)
	{
		$command = "enable && configure terminal && service processor && default acct-policy " . $APolicys;
		$this->sendcommand($command);
	}

	function policy_delete_default_acct($APolicys)
	{
		$command = "enable && configure terminal && service processor && no default acct-policy " . $APolicys;
		$this->sendcommand($command);
	}

	function policy_get_default_fw()
	{
        $ret    = $this->sendcommand("show service processor");
        for($i=0;$i<count($ret);$i++)
        {
        	if (substr($ret[$i],0,17) == "default fw-policy")
        	{
        		return explode(" ",str_replace("default fw-policy ", "", $ret[$i]));
        	}
        }
        return array();
	}

	function policy_set_default_fw($APolicys)
	{
		$command = "enable && configure terminal && service processor && default fw-policy " . $APolicys;
		$this->sendcommand($command);
	}

	function policy_delete_default_fw($APolicys)
	{
		$command = "enable && configure terminal && service processor && no default fw-policy " . $APolicys;
		$this->sendcommand($command);
	}

	###################
    # Quota work blok #
    ###################

	function quota_enabled()
	{
		$res = $this->sendcommand("show quota");
		if ($res[0] == 'Invalid command "quota"')
		{
			return false;
		}
		else
		{
			return true;
		}
	}

	function get_quota($AOid = "all")
	{
		$quota = array();

		if ($AOid == "all")
		{
			$res = $this->sendcommand("show quota");
		}
		else
		{
			$res = $this->sendcommand("show quota oid ".$AOid);
		}
		$oid    = "";
		$policy = "";
		for($i=0;$i<count($res);$i++)
		{
			if (ereg("OID:",$res[$i]) && ereg("OID:",$res[$i]))
			{
                $tmp = explode(" ",$res[$i]);
                $oid = $tmp[1];
                $policy = $tmp[count($tmp)-1];
                $quota[$oid]['policys'][] = $policy;
			}
			else if ($oid <> "" && $policy <> "")
			{
				if (ereg("hardquota",$res[$i]))
				{
					$tmp = explode(" ", $this->kill2space($res[$i]));
					$quota[$oid][$policy][$tmp[0]][$tmp[1]]['use'] = $tmp[2];
					$quota[$oid][$policy][$tmp[0]][$tmp[1]]['value'] = data_size($this->quote2size($tmp[4]));
					$quota[$oid][$policy][$tmp[0]][$tmp[1]]['status'] = $tmp[8];
				}
				else if (ereg("soft-treshold",$res[$i]))
				{

					$quota[$oid][$policy]['status'] = trim(substr($res[$i],strpos($res[$i],"%")+1));
				}
			}
		}
		return $quota;
	}

	#################
	# Monitor block #
	#################

	function monitor_enabled()
	{
		$res = $this->sendcommand("show monitor");
		if ($res[0] == 'Invalid command "show"')
		{
			return false;
		}
		else
		{
			return true;
		}
	}

	function monitor_units()
	{
		$res = $this->sendcommand("show monitor");
		$result = array();
//		print_r($res);
		$tmp = explode(")",$res[3]);
        for($i=0;$i<count($tmp)-1;$i++)
        {
        	$tmp2 = explode("(",$tmp[$i]);
        	$result[] = $tmp2[1];
        }
		return $result;
	}

	function monitor_add($AOid)
	{
		$command = "enable && configure terminal && service monitor && monitor unit " . $AOid;
		$this->sendcommand($command);
	}

	function monitor_delete($AOid)
	{
		$command = "enable && configure terminal && service monitor && no monitor unit " . $AOid;
		$this->sendcommand($command);
	}

	function reload()
	{
		$this->sendcommand("reload");
	}

	function configure_mode()
	{
		$this->configure = false;
		if ($this->version <> "3.4.0")
		{
			$this->configure = true;
		}
		else
		{
			$result = $this->sendcommand("enable");
			if ($result[0] == "#")
			{
				$result = $this->sendcommand("configure terminal");
				if ($result[0] = "(config)#")
				{
					$this->configure = true;
				}
			}
		}
	}

	function gethelp()
	{
		$res = $this->sendcommand("show config");
	}

	function login($user, $passwd)
	{
		$res = $this->sendcommand($user."\r\n".$passwd);
		return (@$res[3] <> "Access denied" || $res[2] == "Welcome, Admin!" ) ? true : false;
	}

	function sendcommand($command)
	{
		if ($this->cfg['client'] == "ctl")
		{
        	exec($this->cfg['ctl'] . " \"" . $command . "\"", $this->buffer);
        	$this->buffer = implode("\n",$this->buffer);
		}
		else
		{
			fwrite($this->fp,$command."\r\n");
			usleep($this->cfg['cmdtimeout']);
			$this->buffer = "";
			$this->response();
		}
		$this->buffer = str_replace($command."\r\n", "", $this->buffer);
//		print $this->buffer;
		$tmp = explode("\n",$this->buffer);
		$tmp2 = array();
		$n = 0;
		for($i=0;$i<count($tmp);$i++)
		{
			if (trim($tmp[$i]) <> "" && trim($tmp[$i]) <> ">" && trim($tmp[$i]) <> "#")
			{
				$tmp2[$n] = trim($tmp[$i]);
				$n++;
			}
		}
//		print_r($tmp2);
//		die("");
		return $tmp2;

	}

	function response() {
		do
		{
			$this->buffer .= fgetc($this->fp);
			$s=socket_get_status($this->fp);
		} while ($s['unread_bytes'] > 0);
	}

	function geterror($no = -1)
	{
		$no = ($no == -1) ? $this->errorno : $no;
		return (isset($this->errormessage[$no])) ? $this->errormessage[$no] : "unknown error no -> ".$no;
	}

	function kill2space($AStr)
	{
		$AStr = trim(str_replace("\t","",$AStr));
		$AStr = str_replace(",","",$AStr);
		$AStr = str_replace(":","",$AStr);
		while( strpos($AStr,"  ") > 0 ) $AStr = str_replace("  ", " ",$AStr);
/*		do
		{
			$AStr = str_replace("  ", " ", $AStr);
		} while (stripos($AStr, "  ") === true);*/
		return $AStr;
	}

	function quote2size($ASize)
	{
    	$tmp = explode(".",$ASize);
    	if (strpos($tmp[1],"K") !== false)
    	{
    		$tmp[0]	= $tmp[0] * 1024;
    	}
    	else if (strpos($tmp[1],"M") !== false)
    	{
    		$tmp[0]	= $tmp[0] * 1024 * 1024;
    	}
    	else if (strpos($tmp[1],"G") !== false)
    	{
    		$tmp[0]	= $tmp[0] * 1024 * 1024 * 1024;
    	}
    	return $tmp[0];

	}

}
?>