<?php
/*
 This program is free software. You can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License.
*/

# include kernel
require_once("./kernel.php");

header("Content-type: text/html");
print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";

if (!$cfg['netams_client_enabled'])
{
	die("<result><error>1</error></result>");
}

# clear array varibles
$policy_list = array(); # policy list
$units_list = array();  # units list
$oid_index = array();   # db oids list

$policy_list = $netams->policy();

if ($netams->errorno > 0)
	die("<result><error>1</error></result>");

$units_list = $netams->units();
if ($netams->errorno > 0)
	die("<result><error>1</error></result>");

$policy = trim($cfg['netams_client_policy']);

if ($policy == "" || policy_id_by($policy) == -1)
	die("<result><error>1</error></result>");

$policy_oid = $policy_list[policy_id_by($policy)]['db_oid'];

# set varibles from GET query
$ip = $_SERVER["REMOTE_ADDR"];

$unit = unit_by_ip($ip);

if(!isset($unit['oid']))
{
	die("<result><error>1</error></result>");
}

$oid = $unit['oid'];

if (cfg("quota_enabled"))
{
	if ($netams->quota_enabled() == false)
	{
		$cfg['quota_enabled'] = false;
	}
	else
	{
		$quota = $netams->get_quota($oid);
		if (!isset($quota[$oid]) || !isset($quota[$oid][$policy]['status']))
		{
			$cfg['quota_enabled'] = false;
		}
		else
		{
			$quota = $quota[$oid][$policy];
		}
	}
}

print "<result><error>0</error>";
print "<version>".version."</version>";
print "<unit "
	 ."oid=\"".$unit['oid']."\" "
	 ."name=\"".replace_space_separator($unit['name'])."\" "
	 ."type=\"".$unit['type']."\" "
	 ."param=\"".$unit['param']."\">"
	 ."</unit>";

print "<conf><client update_time=\"".$cfg['netams_client_update_time']."\"></client><quota enabled=\"".(($cfg['quota_enabled']) ? "true" : "false")."\"></quota><url enabled=\"".(($cfg['urls_monitor_enabled']) ? "true" : "false")."\"></url></conf>";

$sql   = "SELECT `bytes_in` as `in`, `bytes_out` as `out`, `bytes_in` + `bytes_out` as `total`  FROM `summary` WHERE `prefix` = 'M' AND `t_from` = '".mktime(0,0,0,date("m"),date("1"),date("Y"))."' AND `unit_oid` = '".$unit['db_oid']."' AND `policy_oid` = '".$policy_oid."'";
$month = db_query($sql);
$sql   = "SELECT `bytes_in` as `in`, `bytes_out` as `out`, `bytes_in` + `bytes_out` as `total`  FROM `summary` WHERE `prefix` = 'W' AND `t_from` = '".mktime(0,0,0,date("m"),(date("d") - date("w") + 1),date("Y"))."' AND `unit_oid` = '".$unit['db_oid']."' AND `policy_oid` = '".$policy_oid."'";
$week  = db_query($sql);
$sql   = "SELECT `bytes_in` as `in`, `bytes_out` as `out`, `bytes_in` + `bytes_out` as `total`  FROM `summary` WHERE `prefix` = 'D' AND `t_from` = '".mktime(0,0,0,date("m"),date("d"),date("Y"))."' AND `unit_oid` = '".$unit['db_oid']."' AND `policy_oid` = '".$policy_oid."'";
$day   = db_query($sql);
$sql   = "SELECT `bytes_in` as `in`, `bytes_out` as `out`, `bytes_in` + `bytes_out` as `total`  FROM `summary` WHERE `prefix` = 'H' AND `t_from` = '".mktime(date("H"),0,0,date("m"),date("d"),date("Y"))."' AND `unit_oid` = '".$unit['db_oid']."' AND `policy_oid` = '".$policy_oid."'";
$hour  = db_query($sql);

print "<stat><month in=\"".data_size(@$month['in'])."\" out=\"".data_size(@$month['out'])."\" total=\"".data_size(@$month['total'])."\"></month>";
print "<week in=\"".data_size(@$week['in'])."\" out=\"".data_size(@$week['out'])."\" total=\"".data_size(@$week['total'])."\"></week>";
print "<day in=\"".data_size(@$day['in'])."\" out=\"".data_size(@$day['out'])."\" total=\"".data_size(@$day['total'])."\"></day>";
print "<hour in=\"".data_size(@$hour['in'])."\" out=\"".data_size(@$hour['out'])."\" total=\"".data_size(@$hour['total'])."\"></hour></stat>";

if ($cfg['quota_enabled'])
{

	print "<quota status=\"".$quota['status']."\">";
	print "<month status=\"".@$quota['MONTH']['sum']['status']."\" in=\"".@$quota['MONTH']['in']['value']."\" out=\"".@$quota['MONTH']['out']['value']."\" total=\"".@$quota['MONTH']['sum']['value']."\"></month>";
	print "<week status=\"".@$quota['WEEK']['sum']['status']."\" in=\"".@$quota['WEEK']['in']['value']."\" out=\"".@$quota['WEEK']['out']['value']."\" total=\"".@$quota['WEEK']['sum']['value']."\"></week>";
	print "<day status=\"".@$quota['DAY']['sum']['status']."\" in=\"".@$quota['DAY']['in']['value']."\" out=\"".@$quota['DAY']['out']['value']."\" total=\"".@$quota['DAY']['sum']['value']."\"></day>";
	print "<hour status=\"".@$quota['HOUR']['sum']['status']."\" in=\"".@$quota['HOUR']['in']['value']."\" out=\"".@$quota['HOUR']['out']['value']."\" total=\"".@$quota['HOUR']['sum']['value']."\"></hour>";
	print "</quota>";
}

print "</result>";

function debug($AString)
{
	print "<debug>".$AString."</debug>";
}

?>