<?php
/*
 This program is free software. You can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License.
*/

# include kernel
require_once("./kernel.php");

# clear array varibles
$policy_list = array(); # policy list
$units_list = array(); # units list
$oid_index = array(); # db oids list

# tmp varibles
$units_name['user'] = "Пользователь";
$units_name['group'] = "Группа";
$units_name['host'] = "Хост";
$units_name['net'] = "Сеть";
$units_name['cluster'] = "Кластер";

$policy_list = $netams->policy();
if ($netams->errorno > 0)
	error_html("Ошибка при передаче данных NetAms сервера");

$units_list = $netams->units();
if ($netams->errorno > 0)
	error_html("Ошибка при передаче данных NetAms сервера");

# set varibles from GET query
$date = (isset($_GET['date'])) ? $_GET['date'] : date("d.m.Y");
$month =  (isset($_GET['month'])) ? $_GET['month'] : date("m");
$year =  (isset($_GET['year'])) ? $_GET['year'] : date("Y");
$ip =((isset($_GET['ip'])) && is_adv_user()) ? $_GET['ip'] : $_SERVER["REMOTE_ADDR"];

$oid = ((isset($_GET['oid'])) && is_adv_user()) ? $_GET['oid'] : unit_by_ip($ip);
$oid = (is_array($oid) && isset($oid['oid'])) ? $oid['oid'] : $oid;

# load policy and units from netams

if( (is_array($oid) && !isset($oid['oid'])) || $oid == "")
{
	if ( !is_adv_user())
		# if $ip user not define and user don`t have permision as advanced user then die
		die("Access denied");
	else
	{
		# else get first user
		$tmp = units_by("type","net");
		if(count($tmp) == 0) $tmp = units_by("type","host");
		if(count($tmp) == 0) $tmp = units_by("type","group");
		if(count($tmp) == 0) $tmp = units_by("type","user");
		if(count($tmp) == 0) $tmp = units_by("type","cluster");
		$tmp = current($tmp);
		$oid = $tmp['oid'];
	}
}

# convert oid from 16 to 10 code num
$db_oid = base_convert($oid,16,10);

if (cfg("quota_enabled"))
{
	if ($netams->quota_enabled() == false)
	{
		$cfg['quota_enabled'] = false;
	}
	else
	{
		$quota = $netams->get_quota($oid);
		if (!isset($quota[$oid])) $cfg['quota_enabled'] = false;
	}
}
if (!cfg("quota_enabled"))
{
	error_html("У юнита " . replace_space_separator($units_list[unit_id_by("db_oid",$db_oid)]['name']) . " нет квот!");
}

$quota = $quota[$oid];
//print_r($quota);
//die();

$page_title = "Просмотр квот для юнита: " . replace_space_separator($units_list[unit_id_by("db_oid",$db_oid)]['name']);

$table = new Table();
$table->title("Протокол|Часовая&nbsp;квота|Дневная&nbsp;квота|Недельная&nbsp;квота|Месечная&nbsp;квота|Статус");
head_html($page_title);
print "<font class=title>".$page_title."</font>";
$period_array = array("HOUR","DAY","WEEK","MONTH");
for($i=0;$i<count($quota['policys']);$i++)
{
	$policy = $quota['policys'][$i];
	$stat = $quota[$policy];
	$img  = file_exists("images/proto/".$policy.".gif") ? "<img src='images/proto/".$policy.".gif'>&nbsp;" : "";
	$proto_tit = (isset($proto_title[$policy])) ? $proto_title[$policy] : $name;
	$str  = $img.$proto_tit . "|";
	for($n=0;$n<count($period_array);$n++)
	{

		$sum = (isset($stat[$period_array[$n]]['sum']['value'])) ? $stat[$period_array[$n]]['sum']['value'] : "Нет";
		$in  = (isset($stat[$period_array[$n]]['in']['value'])) ? $stat[$period_array[$n]]['in']['value'] : "Нет";
		$out = (isset($stat[$period_array[$n]]['out']['value'])) ? $stat[$period_array[$n]]['out']['value'] : "Нет";
		$etalon = (($sum <> "Нет") || ($in=="Нет"&&$out=="Нет")) ? "sum" : "in";
		$img = (trim(@$stat[$period_array[$n]][$etalon]['status']) == "") ? "<img title='Квота не назначена' src='images/quota/notset.gif'>" : ((@$stat[$period_array[$n]][$etalon]['status'] == "[-]") ? "<img title='Протакол отключен' src='images/quota/disabled.gif'>" : "<img title='Протакол включен' src='images/quota/enabled.gif'>");
		$str .= (($sum <> "Нет") || ($in=="Нет"&&$out=="Нет")) ? $img."&nbsp;".$sum . "|" : $img."&nbsp;".$in . "&nbsp;/&nbsp;" . $out . "|";
	}
	$img = (trim($stat['status']) == "") ? "<img title='Квота не назначена' src='images/quota/notset.gif'>" : (($stat['status'] == "ACTIVE BLOCKED") ? "<img title='Протакол отключен' src='images/quota/disabled.gif'>" : "<img title='Протакол включен' src='images/quota/enabled.gif'>");
	$table->td($str.$img);
}
/*
$table->width(1,"100%");
$table->c1(2);
$table->c1(3);
$table->c1(4);
$table->c1(5);
$table->c1(6);*/
$table->c1();
$table->show();
print "<br>". back_btn();
foot_html();

?>