<?php
/*
 This program is free software. You can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License.
*/

# include kernel
require_once("./kernel.php");

# clear array varibles
$policy_list = array(); # policy list
$units_list = array(); # units list
$oid_index = array(); # db oids list

# tmp varibles
$units_name['user'] = "Пользователь";
$units_name['group'] = "Группа";
$units_name['host'] = "Хост";
$units_name['net'] = "Сеть";
$units_name['cluster'] = "Кластер";

# set varibles from GET query
$date = (isset($_GET['date'])) ? $_GET['date'] : date("d.m.Y");
$month =  (isset($_GET['month'])) ? $_GET['month'] : date("m");
$year =  (isset($_GET['year'])) ? $_GET['year'] : date("Y");
$ip =((isset($_GET['ip'])) && is_adv_user()) ? $_GET['ip'] : $_SERVER["REMOTE_ADDR"];

if (isset($_GET['date']))
{
	$to_period = " за ".$date;
	$tmp = explode(".",$date);
	$sql_date = mktime(0,0,0,$tmp[1],$tmp[0],$tmp[2]);
	$prefix = "D";
}
# else period by default month
else
{
	$mon = array("Январь","Февраль","Март","Апрель","Май","Июнь","Июль","Август","Сентябрь","Октябрь","Ноябрь","Декабрь");
	$to_period = " на ".$mon[$month-1]." ".$year." года";
	$sql_date = mktime(0,0,0,$month, 1, $year);
	$prefix = "M";
}

$table = new Table();

$policy_list = $netams->policy();
if ($netams->errorno > 0)
	error_html("Ошибка при передаче данных NetAms сервера");

$units_list = $netams->units();
if ($netams->errorno > 0)
	error_html("Ошибка при передаче данных NetAms сервера");

//print_r($units_list);

head_html("Сводная статистика");

$units = units_by("parent", "");

if (count($units) > 0)
{
	$title = "Юнит";

	$group_pol = explode(" ", cfg("group_show_policy"));
	for($i=0;$i<count($group_pol);$i++)
	{
		if (policy_id_by($group_pol[$i]) > -1 && $policy_list[policy_id_by($group_pol[$i])]['db_oid'] <> '') {
			$name = $group_pol[$i];
			$img = file_exists("images/proto/".$name.".gif") ? "<img src='images/proto/".$name.".gif'>" : "";
			$name = (isset($proto_title[$name])) ? $proto_title[$name] : $name;
			$title .= "|".$img."&nbsp;".$name;
			$group_policy[] = $policy_list[policy_id_by($group_pol[$i])]['db_oid'];
		}
	}

	$table->title($title);

	$arr = array_keys($units);
	$arr2 = array();
	for($i=0;$i<count($arr);$i++) $arr2[$i] = $units[$arr[$i]]['db_oid'];
	$where_units = implode(" or unit_oid= ", $arr2);
	$where_policy = implode(" or policy_oid = ", $group_policy);
	$sql_traffic = "select `unit_oid` as `oid`, `bytes_in` + `bytes_out` as `total`, policy_oid from `summary` where t_from = ".$sql_date." and ( unit_oid = ".$where_units.") and ( policy_oid = ".$where_policy." ) and prefix = '".$prefix."'";

	# calc users traffic
	$traffic = db_query($sql_traffic, "multi");
	$date = (isset($_GET['date'])) ? "&date=".$_GET['date'] : "";
	$month =  (isset($_GET['month'])) ? "&month=".$_GET['month'] : "";
	$year =  (isset($_GET['year'])) ? "&year=".$_GET['year'] : "";
	$link = $date.$month.$year;

	$sum = array();

	for($i=0;$i<count($traffic);$i++)
	{
		$data[$traffic[$i]['oid']][$traffic[$i]['policy_oid']] = $traffic[$i]['total'];
	}
	if (count($data) > 0)
	{
		$arr = array_keys($data);
		for($i=0;$i<count($arr);$i++)
		{
			$td = "<img src='images/mini_".$units_list[unit_id_by("db_oid",$arr[$i])]['type'].".gif'>&nbsp;<a href='index.php?oid=".$units_list[unit_id_by("db_oid",$arr[$i])]['oid'].$link."'>".replace_space_separator($units_list[unit_id_by("db_oid",$arr[$i])]['name'])."</a>";
			for($n=0;$n<count($group_policy);$n++)
			{
				$sum[$n] = @$sum[$n] + @$data[$arr[$i]][$group_policy[$n]];
				$td .= "|".data_size(@$data[$arr[$i]][$group_policy[$n]]);
			}
			$table->td($td);
		}
		$foot = "<b>Итого:</b>";
		print "<font class=title>Сводная статистика</font>";
		for($i=0;$i<count($group_policy);$i++) $foot .= "|<b>".data_size($sum[$i])."</b>";
		$table->td($foot);
		$table->show();
	}
}
foot_html();

?>