<?php
/*
 This program is free software. You can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License.
*/

# include kernel
require_once("./kernel.php");

$units_list = array(); # units list
$units_list = $netams->units();
if ($netams->errorno > 0)
	error_html("Ошибка при передаче данных NetAms сервера");

$xml = (isset($_GET['xml']) && $_GET['xml'] == "yes") ? true : false;
$date = (isset($_GET['date'])) ? $_GET['date'] : date("d.m.Y");
$month =  (isset($_GET['month'])) ? $_GET['month'] : date("m");
$year =  (isset($_GET['year'])) ? $_GET['year'] : date("Y");
$ip = ((isset($_GET['ip'])) && is_adv_user()) ? $_GET['ip'] : $_SERVER["REMOTE_ADDR"];
$host = (isset($_GET['host'])) ? $_GET['host'] : "";

$oid = ((isset($_GET['oid'])) && is_adv_user()) ? $_GET['oid'] : unit_by_ip($ip);
$oid = (is_array($oid) && isset($oid['oid'])) ? $oid['oid'] : $oid;

$order = (isset($_GET['order'])) ? $_GET['order'] : "count";
$order_by = (isset($_GET['order_by']) && $_GET['order_by'] == "asc") ? "asc" : "desc";

# convert oid from 16 to 10 code num
$db_oid = base_convert($oid,16,10);

if( (is_array($oid) && !isset($oid['oid'])) || $oid == "")
{
	if ( !is_adv_user())
		# if $ip user not define and user don`t have permision as advanced user then die
		die("Access denied");
	else
	{
		# else get first user
		$tmp = units_by("type","user");
		$tmp = current($tmp);
		$oid = $tmp['oid'];
	}
}

# if set date from GET query
if (isset($_GET['date']))
{
	$to_period = " за ".$date;
	$tmp = explode(".",$date);
	$sql_begin_date = mktime(0,0,0,$tmp[1],$tmp[0],$tmp[2]);
	$sql_end_date = mktime(23,59,59,$tmp[1],$tmp[0],$tmp[2]);
}
# else period by default month
else
{
	$mon = array("Январь","Февраль","Март","Апрель","Май","Июнь","Июль","Август","Сентябрь","Октябрь","Ноябрь","Декабрь");
	$to_period = " за ".$mon[$month-1]." ".$year." года";
	$sql_begin_date = mktime(0,0,0,$month, 1, $year);
	$sql_end_date = mktime(23,59,59,$month+1, 0, $year);
}

$type = $units_list[unit_id_by("oid",$oid)]['type'];
$unit_oid = ($type == "user") ? " AND unit_oid = ".$db_oid : "";

$where = ($host == "") ? "layer7 REGEXP '^[a-z0-9-]+[.]*[a-z0-9-]+[.]...*'" : "layer7 LIKE '".base64_decode($host)."%'";
$select = ($host == "") ? "SUBSTRING_INDEX( layer7, '/', 1 )" : "layer7";
$sql = "SELECT COUNT( * ) as `count`, ".$select." as `host` , SUM( len ) as `data_size`, `time` as `time_stamp`, `dst` as `ip`, unit_oid FROM monitor WHERE layer7 != '' ".$unit_oid." AND `time` > '".$sql_begin_date."' AND `time` < '".$sql_end_date."' AND ".$where." GROUP BY 2 ORDER BY `".$order."` ".$order_by;

$row = db_query($sql, "multi");

$count_sum = 0;
$data_sum = 0;

$link = ((isset($_GET['date'])) ? "&date=".$_GET['date'] : "") . ((isset($_GET['month'])) ? "&month=".$_GET['month'] : "") . ((isset($_GET['year'])) ? "&year=".$_GET['year'] : "");

$table = new Table;
$table->cfg("order","data_size");
$table->cfg("order_by","desc");
$table->width(1,"2%");
$table->align(1,"center");
$table->width(8,"2%");
$table->align(8,"center");
$table->align(5,"center");
$table->align(6,"center");
$table->width(5,"80");
$table->width(6,"70");
$table->width(7,"100");
$table->width(3,"100");
$table->width(4,"100");

$table->order(3,"ip");
$table->order(4,"unit_oid");
$table->order(5,"count");
$table->order(6,"data_size");
$table->order(7,"time_stamp");

$table->title("#|Хост|IP|Пользователь|Посещений|Размер|Время|#");

for($i=0;$i<count($row);$i++)
{
	$unit = "<a href='?oid=".base_convert($row[$i]['unit_oid'], 10, 16).$link."'>".$units_list[unit_id_by("db_oid",$row[$i]['unit_oid'])]['name']."</a>";
	$table->td(($i+1)."|<a target=blank href='http://".$row[$i]['host']."'>".$row[$i]['host']."</a>|".int2ip($row[$i]['ip'])."|".$unit."|".$row[$i]['count']."|".data_size($row[$i]['data_size'])."|".date("d.m.y H:i",$row[$i]['time_stamp'])."|<a href='?oid=".$oid.$link."&host=".base64_encode($row[$i]['host'])."'><img src='images/adv_url.gif'></a>");
	$count_sum = $count_sum + $row[$i]['count'];
	$data_sum = $data_sum + $row[$i]['data_size'];
}
$table->td("&nbsp;|&nbsp;|&nbsp;|&nbsp;|<b>".$count_sum."</b>|<b>".data_size($data_sum)."</b>|&nbsp;|&nbsp;");
head_html("Запрошенные страницы ".$to_period."");
$back_btn = ($host <> "") ? btn("Вернуться","?oid=".$oid.$link)."<br><br>" : "";
print "<font class=title>Запрошенные страницы ".$to_period."</font><br>".$back_btn;
$table->show();
foot_html();
print $sql;

function int2ip($int)
{
	$str = base_convert($int,10,16);
	$ip[0]= base_convert($str[0].$str[1],16,10);
	$ip[1]= base_convert($str[2].$str[3],16,10);
	$ip[2]= base_convert($str[4].$str[5],16,10);
	$s7 = (isset($str[7])) ? $str[7] : "";
	//print "!".."<br>";
	$ip[3]= base_convert(@$str[6].$s7,16,10);
	return implode(".",$ip);
}

function ip2int($ip)
{
	$tmp = explode(".",$ip);
	$int[0] = base_convert($tmp[0],10,16);
	$int[1] = base_convert($tmp[1],10,16);
	$int[2] = base_convert($tmp[2],10,16);
	$int[3] = base_convert($tmp[3],10,16);
	for($i=0;$i<count($int);$i++)
	{
		if (strlen($int[$i])==1)
		{
			$int[$i] = "0".$int[$i];
		}
	}
	return base_convert(implode("",$int),16,10);
}



?>